// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.ApiManagement.SmapiModels;

namespace Microsoft.Azure.Management.ApiManagement.SmapiModels
{
    /// <summary>
    /// Operation request details.
    /// </summary>
    public partial class RequestContract
    {
        private string _description;
        
        /// <summary>
        /// Optional. Gets or sets Operation request description.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private IList<ParameterContract> _headers;
        
        /// <summary>
        /// Optional. Gets or sets Collection of operation request headers.
        /// </summary>
        public IList<ParameterContract> Headers
        {
            get { return this._headers; }
            set { this._headers = value; }
        }
        
        private IList<ParameterContract> _queryParameters;
        
        /// <summary>
        /// Optional. Gets or sets Collection of operation request query
        /// parameters.
        /// </summary>
        public IList<ParameterContract> QueryParameters
        {
            get { return this._queryParameters; }
            set { this._queryParameters = value; }
        }
        
        private IList<RepresentationContract> _representations;
        
        /// <summary>
        /// Optional. Gets or sets Collection of operation request
        /// representations.
        /// </summary>
        public IList<RepresentationContract> Representations
        {
            get { return this._representations; }
            set { this._representations = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RequestContract class.
        /// </summary>
        public RequestContract()
        {
            this.Headers = new LazyList<ParameterContract>();
            this.QueryParameters = new LazyList<ParameterContract>();
            this.Representations = new LazyList<RepresentationContract>();
        }
    }
}
