// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// Copy activity properties.
    /// </summary>
    public partial class CopyActivityProperties
    {
        private CopySink _sink;
        
        /// <summary>
        /// Required. Copy activity sink.
        /// </summary>
        public CopySink Sink
        {
            get { return this._sink; }
            set { this._sink = value; }
        }
        
        private CopySource _source;
        
        /// <summary>
        /// Required. Copy activity source.
        /// </summary>
        public CopySource Source
        {
            get { return this._source; }
            set { this._source = value; }
        }
        
        private CopyTranslator _translator;
        
        /// <summary>
        /// Optional. Copy activity translator. If not specificed, tabular
        /// translator is used.
        /// </summary>
        public CopyTranslator Translator
        {
            get { return this._translator; }
            set { this._translator = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CopyActivityProperties class.
        /// </summary>
        public CopyActivityProperties()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the CopyActivityProperties class with
        /// required arguments.
        /// </summary>
        public CopyActivityProperties(CopySource source, CopySink sink)
            : this()
        {
            if (source == null)
            {
                throw new ArgumentNullException("source");
            }
            if (sink == null)
            {
                throw new ArgumentNullException("sink");
            }
            this.Source = source;
            this.Sink = sink;
        }
    }
}
