// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// The properties of the subscription quptas response.
    /// </summary>
    public partial class SubscriptionQuotasProperties
    {
        private int _currentCount;
        
        /// <summary>
        /// Required. Gets or sets the streaming units count currently used for
        /// the stream analytics for the subscription in this region.
        /// </summary>
        public int CurrentCount
        {
            get { return this._currentCount; }
            set { this._currentCount = value; }
        }
        
        private int _maxCount;
        
        /// <summary>
        /// Required. Gets or sets the max streaming units count allowed for
        /// the stream analytics for the subscription in this region.
        /// </summary>
        public int MaxCount
        {
            get { return this._maxCount; }
            set { this._maxCount = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SubscriptionQuotasProperties
        /// class.
        /// </summary>
        public SubscriptionQuotasProperties()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the SubscriptionQuotasProperties
        /// class with required arguments.
        /// </summary>
        public SubscriptionQuotasProperties(int maxCount, int currentCount)
            : this()
        {
            this.MaxCount = maxCount;
            this.CurrentCount = currentCount;
        }
    }
}
