// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.Management.Automation.Models;

namespace Microsoft.WindowsAzure.Management.Automation
{
    /// <summary>
    /// Service operation for automation activities.  (see
    /// http://aka.ms/azureautomationsdk/activityoperations for more
    /// information)
    /// </summary>
    public partial interface IActivityOperations
    {
        /// <summary>
        /// Retrieve the activity in the module identified by module name and
        /// activity name.  (see
        /// http://aka.ms/azureautomationsdk/activityoperations for more
        /// information)
        /// </summary>
        /// <param name='automationAccount'>
        /// The automation account name.
        /// </param>
        /// <param name='moduleName'>
        /// The name of module.
        /// </param>
        /// <param name='activityName'>
        /// The name of activity.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the get activity operation.
        /// </returns>
        Task<ActivityGetResponse> GetAsync(string automationAccount, string moduleName, string activityName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Retrieve a list of activities in the module identified by module
        /// name.  (see http://aka.ms/azureautomationsdk/activityoperations
        /// for more information)
        /// </summary>
        /// <param name='automationAccount'>
        /// The automation account name.
        /// </param>
        /// <param name='moduleName'>
        /// The name of module.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the list activity operation.
        /// </returns>
        Task<ActivityListResponse> ListAsync(string automationAccount, string moduleName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Retrieve next list of activities in the module identified by module
        /// name.  (see http://aka.ms/azureautomationsdk/activityoperations
        /// for more information)
        /// </summary>
        /// <param name='nextLink'>
        /// The link to retrieve next set of items.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the list activity operation.
        /// </returns>
        Task<ActivityListResponse> ListNextAsync(string nextLink, CancellationToken cancellationToken);
    }
}
