// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Scheduler.Models;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// Active Directory OAuth authentication for job
    /// </summary>
    public partial class AADOAuthAuthentication : HttpAuthentication
    {
        private string _audience;
        
        /// <summary>
        /// Optional. Gets or sets the audience.
        /// </summary>
        public string Audience
        {
            get { return this._audience; }
            set { this._audience = value; }
        }
        
        private string _clientId;
        
        /// <summary>
        /// Optional. Gets or sets the client id.
        /// </summary>
        public string ClientId
        {
            get { return this._clientId; }
            set { this._clientId = value; }
        }
        
        private string _secret;
        
        /// <summary>
        /// Optional. Gets or sets the secret.
        /// </summary>
        public string Secret
        {
            get { return this._secret; }
            set { this._secret = value; }
        }
        
        private string _tenant;
        
        /// <summary>
        /// Optional. Gets or sets the tenant.
        /// </summary>
        public string Tenant
        {
            get { return this._tenant; }
            set { this._tenant = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AADOAuthAuthentication class.
        /// </summary>
        public AADOAuthAuthentication()
        {
        }
    }
}
