// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.ServiceBus.Models;

namespace Microsoft.WindowsAzure.Management.ServiceBus.Models
{
    public partial class ServiceBusNamespaceCreateParameters
    {
        private bool _createACSNamespace;
        
        /// <summary>
        /// Optional. Whether or not ACS authentication is needed for
        /// ServiceBus.
        /// </summary>
        public bool CreateACSNamespace
        {
            get { return this._createACSNamespace; }
            set { this._createACSNamespace = value; }
        }
        
        private NamespaceType _namespaceType;
        
        /// <summary>
        /// Required. Gets or sets the namespace type.
        /// </summary>
        public NamespaceType NamespaceType
        {
            get { return this._namespaceType; }
            set { this._namespaceType = value; }
        }
        
        private string _region;
        
        /// <summary>
        /// Required. The namespace region.
        /// </summary>
        public string Region
        {
            get { return this._region; }
            set { this._region = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ServiceBusNamespaceCreateParameters class.
        /// </summary>
        public ServiceBusNamespaceCreateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ServiceBusNamespaceCreateParameters class with required arguments.
        /// </summary>
        public ServiceBusNamespaceCreateParameters(string region, NamespaceType namespaceType)
            : this()
        {
            if (region == null)
            {
                throw new ArgumentNullException("region");
            }
            this.Region = region;
            this.NamespaceType = namespaceType;
        }
    }
}
