// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a delete mapping input object.
    /// </summary>
    public partial class NetworkUnMappingInput
    {
        private string _primaryNetworkId;
        
        /// <summary>
        /// Required. Primary network Id.
        /// </summary>
        public string PrimaryNetworkId
        {
            get { return this._primaryNetworkId; }
            set { this._primaryNetworkId = value; }
        }
        
        private string _primaryServerId;
        
        /// <summary>
        /// Required. Primary server Id.
        /// </summary>
        public string PrimaryServerId
        {
            get { return this._primaryServerId; }
            set { this._primaryServerId = value; }
        }
        
        private string _recoveryServerId;
        
        /// <summary>
        /// Required. Recovery server Id.
        /// </summary>
        public string RecoveryServerId
        {
            get { return this._recoveryServerId; }
            set { this._recoveryServerId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NetworkUnMappingInput class.
        /// </summary>
        public NetworkUnMappingInput()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the NetworkUnMappingInput class with
        /// required arguments.
        /// </summary>
        public NetworkUnMappingInput(string primaryServerId, string primaryNetworkId, string recoveryServerId)
            : this()
        {
            if (primaryServerId == null)
            {
                throw new ArgumentNullException("primaryServerId");
            }
            if (primaryNetworkId == null)
            {
                throw new ArgumentNullException("primaryNetworkId");
            }
            if (recoveryServerId == null)
            {
                throw new ArgumentNullException("recoveryServerId");
            }
            this.PrimaryServerId = primaryServerId;
            this.PrimaryNetworkId = primaryNetworkId;
            this.RecoveryServerId = recoveryServerId;
        }
    }
}
