// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Sql.Models;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Represents a dropped Azure SQL Database that can be restored.
    /// </summary>
    public partial class RestorableDroppedDatabase : SqlModelCommon
    {
        private DateTime _creationDate;
        
        /// <summary>
        /// Optional. Gets the date this database was created.
        /// </summary>
        public DateTime CreationDate
        {
            get { return this._creationDate; }
            set { this._creationDate = value; }
        }
        
        private DateTime _deletionDate;
        
        /// <summary>
        /// Optional. Gets the date this database was deleted.
        /// </summary>
        public DateTime DeletionDate
        {
            get { return this._deletionDate; }
            set { this._deletionDate = value; }
        }
        
        private string _edition;
        
        /// <summary>
        /// Optional. Gets the database resource's edition.
        /// </summary>
        public string Edition
        {
            get { return this._edition; }
            set { this._edition = value; }
        }
        
        private string _entityId;
        
        /// <summary>
        /// Optional. Gets the entity ID of the database.
        /// </summary>
        public string EntityId
        {
            get { return this._entityId; }
            set { this._entityId = value; }
        }
        
        private long _maximumDatabaseSizeInBytes;
        
        /// <summary>
        /// Optional. Gets the maximum size of this database expressed in bytes.
        /// </summary>
        public long MaximumDatabaseSizeInBytes
        {
            get { return this._maximumDatabaseSizeInBytes; }
            set { this._maximumDatabaseSizeInBytes = value; }
        }
        
        private System.DateTime? _recoveryPeriodStartDate;
        
        /// <summary>
        /// Optional. Gets the starting date of the restorable period for this
        /// database.
        /// </summary>
        public System.DateTime? RecoveryPeriodStartDate
        {
            get { return this._recoveryPeriodStartDate; }
            set { this._recoveryPeriodStartDate = value; }
        }
        
        private string _serverName;
        
        /// <summary>
        /// Optional. Gets the name of the server.
        /// </summary>
        public string ServerName
        {
            get { return this._serverName; }
            set { this._serverName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RestorableDroppedDatabase class.
        /// </summary>
        public RestorableDroppedDatabase()
        {
        }
    }
}
