// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class represents band width setting
    /// </summary>
    public partial class BandwidthSetting
    {
        private int _createdFromTemplateId;
        
        /// <summary>
        /// Required. Gets or sets the id of the template from which the
        /// bandwidth setting is created.
        /// </summary>
        public int CreatedFromTemplateId
        {
            get { return this._createdFromTemplateId; }
            set { this._createdFromTemplateId = value; }
        }
        
        private string _instanceId;
        
        /// <summary>
        /// Optional. Gets or sets the instance id of the bandwidth setting
        /// </summary>
        public string InstanceId
        {
            get { return this._instanceId; }
            set { this._instanceId = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the name of the bandwidth setting
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private OperationInProgress _operationInProgress;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether there is an
        /// operation in progress
        /// </summary>
        public OperationInProgress OperationInProgress
        {
            get { return this._operationInProgress; }
            set { this._operationInProgress = value; }
        }
        
        private IList<BandwidthSchedule> _schedules;
        
        /// <summary>
        /// Required. Gets or sets bandwidth schedule associated current
        /// bandwidth setting.
        /// </summary>
        public IList<BandwidthSchedule> Schedules
        {
            get { return this._schedules; }
            set { this._schedules = value; }
        }
        
        private int _volumeCount;
        
        /// <summary>
        /// Optional. Gets or sets the count of volumes to which the bandwidth
        /// setting is applied.
        /// </summary>
        public int VolumeCount
        {
            get { return this._volumeCount; }
            set { this._volumeCount = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BandwidthSetting class.
        /// </summary>
        public BandwidthSetting()
        {
            this.Schedules = new List<BandwidthSchedule>();
        }
        
        /// <summary>
        /// Initializes a new instance of the BandwidthSetting class with
        /// required arguments.
        /// </summary>
        public BandwidthSetting(string name, List<BandwidthSchedule> schedules, int createdFromTemplateId)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (schedules == null)
            {
                throw new ArgumentNullException("schedules");
            }
            this.Name = name;
            this.Schedules = schedules;
            this.CreatedFromTemplateId = createdFromTemplateId;
        }
    }
}
